"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _getScrollInfo = require("get-scroll-info");

var _easingLib = require("easing-lib");

var isRunning = false;

var _call = function _call(func, scrollNode) {
  return function () {
    if ("function" !== typeof func) {
      return;
    }

    func(scrollNode);
  };
};
/**
 *  !!Important!! any logic change need take care isRunning
 */


var smoothScrollTo = function smoothScrollTo(to, duration, el, callback) {
  var scrollNode = (0, _getScrollInfo.getScrollNode)(el);

  var cb = _call(callback, scrollNode);

  if (isRunning) {
    isRunning = false;
    setTimeout(function () {
      scrollNode.scrollTop = to;
      cb();
    });
    return false;
  }

  if (!duration) {
    duration = 900;
  }

  var from = scrollNode.scrollTop;
  var go = to - from;

  if (!go) {
    isRunning = false;
    cb();
    return;
  }

  (0, _easingLib.aniTimeout)({
    isContinue: function isContinue(elapsedTime) {
      var progress = (0, _easingLib.easeInOutCubic)(elapsedTime, from, go, duration);
      scrollNode.scrollTop = progress;

      if (isRunning) {
        return true;
      }
    },
    cancel: function cancel() {
      return isRunning = false;
    },
    done: function done() {
      return isRunning = false;
    }
  }, duration);
  isRunning = true;
};

var _default = smoothScrollTo;
exports["default"] = _default;
module.exports = exports.default;