import { getScrollNode } from "get-scroll-info";
import { easeInOutCubic, aniTimeout } from "easing-lib";
var isRunning = false;

var _call = function _call(func, scrollNode) {
  return function () {
    if ("function" !== typeof func) {
      return;
    }

    func(scrollNode);
  };
};
/**
 *  !!Important!! any logic change need take care isRunning
 */


var smoothScrollTo = function smoothScrollTo(to, duration, el, callback) {
  var scrollNode = getScrollNode(el);

  var cb = _call(callback, scrollNode);

  if (isRunning) {
    isRunning = false;
    setTimeout(function () {
      scrollNode.scrollTop = to;
      cb();
    });
    return false;
  }

  if (!duration) {
    duration = 900;
  }

  var from = scrollNode.scrollTop;
  var go = to - from;

  if (!go) {
    isRunning = false;
    cb();
    return;
  }

  aniTimeout({
    isContinue: function isContinue(elapsedTime) {
      var progress = easeInOutCubic(elapsedTime, from, go, duration);
      scrollNode.scrollTop = progress;

      if (isRunning) {
        return true;
      }
    },
    cancel: function cancel() {
      return isRunning = false;
    },
    done: function done() {
      return isRunning = false;
    }
  }, duration);
  isRunning = true;
};

export default smoothScrollTo;